<script>
    import { onMount } from 'svelte'
    import {
        acceptFriend,
        deleteFriend,
        getRelationStatus,
        ignoreFriend,
        relations,
        requestFriend,
    } from 'lib/relations'

    export let username

    let status = undefined

    const refreshRelation = async () => {
        status = await getRelationStatus(username)
    }

    onMount(async () => refreshRelation())

    relations.subscribe(() => refreshRelation())
</script>

{#if status === 'friend'}
    <button class="danger" on:click|once={deleteFriend(username)}>
        Supprimer
    </button>
{:else if status === 'request'}
    <button on:click|once={ignoreFriend(username)} class="dismiss">
        Ignorer
    </button>
    <button on:click|once={acceptFriend(username)}> Accepter </button>
{:else if status === 'pending'}
    <div>
        <p>Demande envoyée</p>
        <button on:click|once={deleteFriend(username)} class="dismiss">
            Annuler
        </button>
    </div>
{:else}<button on:click|once={requestFriend(username)}>Ajouter</button>{/if}

<style lang="postcss">
    div {
        @apply text-right;

        p {
            @apply text-blueGray-700 italic;
        }
    }

    button {
        @apply py-1 px-2 bg-opacity-0 text-teal-500 border-2 border-teal-500 font-normal leading-tight tracking-wide rounded-full transition-colors duration-150 ease-out;

        &:hover {
            @apply bg-opacity-100 bg-teal-500 text-teal-50;
        }

        &.danger {
            @apply border-2 border-red-500 text-red-500;

            &:hover {
                @apply bg-opacity-100 bg-red-500 text-red-50;
            }
        }

        &.dismiss {
            @apply border-none text-blueGray-400 underline p-0;

            &:hover {
                @apply bg-opacity-0 border-none text-blueGray-600;
            }
        }
    }
</style>
